/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.geometries.viewer3d.controls.light_editor;

import org.visnow.vn.geometries.viewer3d.lights.EditablePointLight;

/**
 *
 ** @author Krzysztof S. Nowinski, University of Warsaw ICM
 */
public class PointLightEditor extends javax.swing.JPanel
{

    private int iEditor;
    private EditablePointLight light = null;
    private PointLightsEditorPanel parentPanel = null;

    /**
     * Creates new form DirectionalLightEditor
     */
    public PointLightEditor()
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        positionEditToggle = new javax.swing.JToggleButton();
        jButton1 = new javax.swing.JButton();
        lightColorEditor = new org.visnow.vn.geometries.viewer3d.controls.light_editor.PointLightColorEditor();
        switchBox = new javax.swing.JCheckBox();

        setMinimumSize(new java.awt.Dimension(180, 22));
        setPreferredSize(new java.awt.Dimension(220, 22));
        setLayout(new java.awt.GridBagLayout());

        positionEditToggle.setFont(new java.awt.Font("Dialog", 0, 12));
        positionEditToggle.setText("position");
        positionEditToggle.setBorder(null);
        positionEditToggle.setMargin(new java.awt.Insets(3, 1, 3, 1));
        positionEditToggle.setMaximumSize(new java.awt.Dimension(56, 21));
        positionEditToggle.setMinimumSize(new java.awt.Dimension(56, 21));
        positionEditToggle.setName("positionEditToggle"); // NOI18N
        positionEditToggle.setPreferredSize(new java.awt.Dimension(56, 21));
        positionEditToggle.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                positionEditToggleActionPerformed(evt);
            }
        });
        add(positionEditToggle, new java.awt.GridBagConstraints());

        jButton1.setFont(new java.awt.Font("Dialog", 0, 10)); // NOI18N
        jButton1.setText("*");
        jButton1.setBorder(null);
        jButton1.setMargin(new java.awt.Insets(2, 6, 2, 2));
        jButton1.setMaximumSize(new java.awt.Dimension(21, 21));
        jButton1.setMinimumSize(new java.awt.Dimension(21, 21));
        jButton1.setName("jButton1"); // NOI18N
        jButton1.setPreferredSize(new java.awt.Dimension(21, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(3, 0, 3, 5);
        add(jButton1, gridBagConstraints);

        lightColorEditor.setName("lightColorEditor"); // NOI18N

        javax.swing.GroupLayout lightColorEditorLayout = new javax.swing.GroupLayout(lightColorEditor);
        lightColorEditor.setLayout(lightColorEditorLayout);
        lightColorEditorLayout.setHorizontalGroup(
                lightColorEditorLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGap(0, 106, Short.MAX_VALUE)
                );
        lightColorEditorLayout.setVerticalGroup(
                lightColorEditorLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGap(0, 21, Short.MAX_VALUE)
                );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 6, 0, 5);
        add(lightColorEditor, gridBagConstraints);

        switchBox.setMaximumSize(new java.awt.Dimension(26, 26));
        switchBox.setMinimumSize(new java.awt.Dimension(26, 26));
        switchBox.setName("switchBox"); // NOI18N
        switchBox.setPreferredSize(new java.awt.Dimension(26, 26));
        switchBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                switchBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
        gridBagConstraints.insets = new java.awt.Insets(2, 0, 2, 0);
        add(switchBox, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void positionEditToggleActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_positionEditToggleActionPerformed
    {//GEN-HEADEREND:event_positionEditToggleActionPerformed
        if (parentPanel != null)
            parentPanel.changePositionEdit(iEditor, positionEditToggle.isSelected());
    }//GEN-LAST:event_positionEditToggleActionPerformed

    private void switchBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_switchBoxActionPerformed
    {//GEN-HEADEREND:event_switchBoxActionPerformed
        light.setEnabled(switchBox.isSelected());
    }//GEN-LAST:event_switchBoxActionPerformed

    public void setiEditor(int iEditor)
    {
        this.iEditor = iEditor;
    }

    public void setLight(EditablePointLight light)
    {
        this.light = light;
        lightColorEditor.setLight(light);
    }

    public void setParentPanel(PointLightsEditorPanel parentPanel)
    {
        this.parentPanel = parentPanel;
    }

    public void unsetPositionEdit()
    {
        positionEditToggle.setSelected(false);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JButton jButton1;
    protected org.visnow.vn.geometries.viewer3d.controls.light_editor.PointLightColorEditor lightColorEditor;
    protected javax.swing.JToggleButton positionEditToggle;
    protected javax.swing.JCheckBox switchBox;
    // End of variables declaration//GEN-END:variables
}
